<?php
/*

 $Id: user.php,v 1.22 2003/08/22 15:08:29 vollmerk Exp $
 $Source: /a1/cvsroot/maint/docs/user.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*!
	@header User Document
	This actually executes user commands passed to it allowing users
	to do things like add users, change user permissions and remove
	users.

*/


/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
	check_session();

	setup_user_environment($action, $zone_id);

/* End House Keeping */

// process any submits that may come our way
$title = "Manage Zone Users";




?>


<? 

/* Updates user prefs special case must be done before header */
if ($action == "update_user_prefs") {

	/* Double check and make sure they are legit */
	if ($user->is_admin || $user->username == $username) {

	$user_view = new User($username);

        $user_view->set_preferred_zone($zone_id);
        $user_view->set_ui_size($ui_size);
        $user_view->set_list_view($list_view);
        $user_view->set_color_template($template);
        $user_view->set_host_view($host_view);

	/* If it's the current user set their session up */
	if ($username == $user->username || $user->is_admin) {
		$user->preferred_zone = $zone_id;
		$user->ui_size = $ui_size;
		$user->list_view = $list_view;
		$user->color_template = $template;
		$user->host_view = $host_view;
		$conf['color'] = new Color($user->color_template);
	} //if is the user

	} //has access to user object	

	$action = 'show_user';

} //action == update_user_prefs

/* Done after user prefs so they take effect */
show_template('header');

/*!
	@function set_user_passwd
	@discussion resets a users password, this
		    only works on mysql_auth'd people
*/
if ( $action == "set_local_password" AND $user->check_mysql_auth_name($username) AND ($user->is_admin || $user->username == $username) ) {

	// If user isn't the admin we need to check the pass's
	if (!$user->is_admin) { 
		
		if (!$user->check_password($username,$current_pass)) {
			$conf['error']->add_error('current_pass',"Incorrect Current Password");
		}
		if ($new_pass !== $confirm_pass) { 
			$conf['error']->add_error('confirm_pass',"New Passwords don't match");
		}

	} // if they aren't a admin

	if (strlen($new_pass) < 8) { 
		$conf['error']->add_error('new_pass',"Password must be at least 8 chr");
	}

	if (!$conf['error']->error_state) { 

		$user->set_passwd($new_pass,$username);
		$conf['ui']->display_confirmation("Password Changed","$username's password has been changed.", $conf['web_path'] . "/index.php");
	} // if no errors

	else { 
		$action = 'show_user';
	}


} // set_local_password

// alright, are we trying to delete a user _and_ we have that user?
if ( $action == 'delete_user' && $user_id) {
	$conf['zone']->delete_user($user_id);
	$action = 'show_users';
}
elseif ( $action == 'set_user_level' ) {
	$conf['zone']->set_user_level($user_id, $level);
	$action = 'show_users';
}
// admins can "become" users for debugging purposes
elseif ( $action == 'become_user' && $user->is_admin ) {
	$user = new User($user_id);

	$conf['ui']->display_confirmation("User Change","Become User sucessful, you are now $user->username", $conf['web_path']);
}

/*!
	@function add_user
	@discussion this adds a new user to maintain
		    depending on if we are doing mysql auth
		    or ldap auth we need to different things
*/
elseif ( $action == 'add_user' ) {

	if ( ! $username ) {
		$conf['error']->add_error('username', "Please enter a username.");
		// they screwed up, we better set the action for them too
		$action = 'show_add_user';
	}

	// Ldap auth is enabled
	if ($conf['ui']->ldap_auth()) {
		$auth_ldap = $user->check_auth_name($username);
	} //check auth name

	// mysql auth is enabled
	if ($conf['ui']->mysql_auth()) {
		$auth_mysql = $user->check_mysql_auth_name($username);
	} // check mysql auth

	if (!$auth_mysql && !$auth_ldap) { 
		$conf['error']->add_error('username',"Invalid username");
	}

	// Do a generic, level check you can only add where $level <= yours
	if ($user->get_level() < $level OR $user->is_guest) { 
		$conf['error']->add_error('username', "Error you attempted to create a user with more permissions than yourself");
	}

	// If they set a username then...
	if (!$conf['error']->error_state) {
		// If they want to add this user to all their zones
		if ($all_my_zones) {
			$zones = $user->get_zone_admin_zones();
			/* Recurse through the zones and add them */
			if (!$zones) { 
				$conf['error']->add_error('username',"Error no Zones found. Either you are an admin, and are not allowed to add users in this way or you do not have sufficient rights to add users");
				$action = 'show_add_user';
			}
			else {
				foreach ($zones as $zone) {
					$zone->add_zone_user($username,$level);
				} //foreach

		                $conf['ui']->display_confirmation("User Added", "The $username has been added to all zones which you own" , $conf['web_path'] . "/user.php?action=show_users");		
			} // end else if zones

		} //all_my_zones

		else {
			$conf['zone']->add_zone_user($username, $level);
			$action = 'show_users';
		} //else not all_my_zones

	} // if no errors
	
	else { 
		$action = 'show_add_user';
	}


} // add_user

/*!
	@function create_mysql_user
	@discussion actually creates the new mysql_user
*/
elseif ($action == 'create_mysql_user' AND $user->is_admin) {

	//If we are using ldap_auth check for 
	if ($conf['ui']->ldap_auth()) { 
	        if (!$user->check_auth_name($username)) {

	                $conf['error']->add_error('username', "Username already exists in LDAP.");
	                $action = 'show_add_user';
	
	        } //check auth name
	} // if ldap_auth()

	//Make sure there isn't a local user already with the same name
	if ($user->check_mysql_auth_name($username)) {
		$conf['error']->add_error('username',"User already exists.");
	}

	//Make sure they set something for the username
	if (strlen($username) < 1) {
		$conf['error']->add_error('username', "Username must be at least 1 chr");
	}

	//Make sure their password is at least 6 chrs
	if (strlen($password) < 6) { 
		$conf['error']->add_error('password', "Error password must be at least 6 chr");
	}

	if (!$conf['error']->error_state) { 
		$user->create_mysql_user($username,$password);
		$conf['ui']->display_confirmation("User Create", $username . " has been added as a local accout for maintain", $conf['web_path'] . "/index.php");

	} // if no error


	else {
		$action = 'show_create_mysql_user';
	}


} // create_mysql_user

/*!
	@function delete_local_user
	@discussion Must be a full admin, deletes a local user
*/
elseif ($action == 'delete_local_user' AND $user->is_admin) { 

	$user_obj = new User($username);

	//First remove any zone_range mappings they have
	$zones = $user_obj->zones();

	// this is a hack of sorts to catch full admin permissions
	$zones[] = new Zone(0);

	foreach ($zones as $zone) { 
		$zone->delete_user($username);
	}

	$user_obj->delete();

	$conf['ui']->display_confirmation("$username Deleted","",$conf['web_path'] . "/index.php");

} // delete_local_user


/*****************************/
/* End of if modifying block */
/*****************************/


// show us some users baby!
if ( $action == 'show_users' ) {
	?> <font class="header1"><?= $title ?></font><br /> <?
	
	$users = $conf['zone']->get_users();
	$conf['ui']->show_users($users);
}

/*!
	@function show_local_users
	@discussion Show the local accounts on maintain
*/
elseif ($action == 'show_local_users') { 

	$users = $conf['ui']->get_users("SELECT username FROM user WHERE type='mysql'");
	$conf['ui']->show_local_users($users);

} // show_local_users


// show the single user view
elseif ($action == 'show_user') {
	$title = "Viewing $username";
	?> <font class="header1"><?= $title; ?></font><br /><br /> <?
	
	$user_view = new User($username);
	require ($conf['prefix'] . "/templates/show_user.inc"); 

} //action==show_user

/*!
	@function show_create_mysql_user
	@discussion if we are mysql_authin then show the 
		    mysql_create_user template
*/
elseif ($action == 'show_create_mysql_user' AND $conf['ui']->mysql_auth() AND $user->is_admin) { 
	
	require ($conf['prefix'] . "/templates/show_add_user.inc");

} // show_create_mysql_auth


//shows the user add form
elseif ( $action == 'show_add_user' ) {
	?> <font class="header1"><?= $title ?></font><br /> <?
	$conf['ui']->show_add_user();	
}

show_template('footer');

?>
