<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: show_option.inc,v 1.10 2003/08/05 23:01:09 vollmerk Exp $
 $Source: /a1/cvsroot/maint/templates/show_option.inc,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Show Options Template
	Show a single DHCP option for a specific subnet or workgroup.

*/

if ($type == 'subnet') {
	$object = new Subnet($type_id);
}
elseif ($type == 'workgroup') { 
	$object = new Workgroup($type_id);
}

?>

<p class="header2">
<? if ( $action == 'show_create' ) { ?>
	Create a new DHCP Option for the <?= $object->name . " " . $type; ?>
<? } else { ?>
	Update a DHCP Option for the <?= $object->name . " " . $type; ?>
<? } ?>
</p>

<?
$items = array();
$items[] = "<a href=\"" . $conf['web_path'] . "/" . $type . ".php?action=edit&amp;" . $type . "_id=$type_id\">View the $type assoicated with this Option</a>";
$items[] = "<a href=\"" . $conf['web_path'] . "/option.php?action=show_options&amp;" . $type . "_id=$type_id\">View DHCP Options for this $type</a>";
$conf['ui']->display_top_widget($items);
?>

<? if ( $conf['error']->get_status('option_top') ) { ?>
<p><? $conf['error']->show_message('option_top'); ?></p>
<? } ?>

<? show_template('tborder'); ?>

<form name="edit_option" style="Display:inline" enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/option.php">
<table border="0" cellpadding="2" cellspacing="0" width="100%">
        <tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" width="100%">
                <td title="<? $conf['help']->display_plain_txt("options_dhcp"); ?>"><? $conf['help']->show_help_link("options_dhcp"); ?> DHCP Option: </td>
                <td>
		<? $conf['ui']->show_dhcp_option_select($option->id, $type); ?>
                </td>
        </tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" width="100%">
                <td title="<? $conf['help']->display_plain_txt("options_value"); ?>"><? $conf['help']->show_help_link("options_value"); ?> Value: </td>
                <td><input name="value" value='<?= $option->value ?>' size="64" maxlength="128" />
		<? $conf['error']->show_message('option_value'); ?>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->display_plain_txt('option_host'); ?>"><? $conf['help']->show_help_link('option_host'); ?> Set to Host Level:</td>
		<td>
			<input type="checkbox" name="option_type" value="host" <? if ($option->option_type == 'host') { echo "CHECKED"; } ?> />
		</td>
	</tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td>&nbsp;</td>
		<td>
		<? if ( $action == 'show_create' ) { ?>
			<input type="submit" name="action" value="Create" />
			<input type="hidden" name="type" value="<?= $type ?>" />
			<input type="hidden" name="type_id" value="<?= $type_id ?>" />
		<? } else { ?>
			<input type="submit" name="action" value="Update" />
			<input type="submit" name="action" value="Delete" />
			<input type="hidden" name="option_id" value="<?= $option->id ?>" />
			<input type="hidden" name="type" value="<?= $option->type ?>" />
			<input type="hidden" name="type_id" value="<?= $option->type_id ?>" />
		<? } ?>
		</td>
	</tr>
</table>
</form>

<? show_template('bborder'); ?>
