<?php

/*

 $Id: show_subnet.inc,v 1.11 2003/08/13 00:02:30 vollmerk Exp $
 $Source: /a1/cvsroot/maint/templates/show_subnet.inc,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Show Subnet Document
	Show a single subnet, and it's options
*/

//create the history object for this
$history = $subnet->object_history->get_history();

?>

<p class="header2">
<? if ( $action == 'show_create' ) { ?>
	Create a new Subnet
<? } else { ?>
	Update a Subnet
<? } ?>
</p>

<? if ( $conf['error']->get_status('subnet_top') ) { ?>
<p><? $conf['error']->show_message('subnet_top'); ?></p>
<? } ?>

<? 
if ( $action != 'show_create' ) { 
$items[] = "<a href=\"" . $conf['web_path'] . "/option.php?action=show_options&type=subnet&subnet_id=" . $subnet->id . "\">View DHCP Options for this Subnet</a>";
} 
$items[] = "<a href=\"" . $conf['web_path'] . "/subnet.php?action=show_subnets\">View all Subnets</a>";
$items[] = "<a href=\"" . $conf['web_path'] . "/subnet.php?action=show_unused_subnets\">View unused Subnets</a>";
$conf['ui']->display_top_widget($items);
?>

<form name="edit_subnet" enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/subnet.php" style="Display:inline">
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%" bgcolor="<?=  $conf['color']->bg['body_dark']; ?>">
        <tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" width="100%">
                <td title="<? $conf['help']->display_plain_txt("subnet_name"); ?>"><? $conf['help']->show_help_link('subnet_name'); ?> Name: </td>
                <td><input name="name" value="<?=  $subnet->name ?>" size="30" maxlength="255" />
		<? 
		if ( $conf['error']->get_status('subnet_name') ) {
			$conf['error']->show_message('subnet_name');
		}
		?>
                </td>
        </tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" width="100%">
                <td title="<? $conf['help']->display_plain_txt("subnet_mask"); ?>"><? $conf['help']->show_help_link('subnet_mask'); ?> Subnet: </td>
                <td><input name="subnet_mask" value="<?=  $subnet->subnet->ip_addr ?>" size="18" maxlength="15" />
		<? 
		if ( $conf['error']->get_status('subnet_mask') ) {
			$conf['error']->show_message('subnet_mask');
		}
		?>
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->display_plain_txt("subnet_netmask"); ?>"><? $conf['help']->show_help_link('subnet_netmask'); ?>Subnet Netmask: </td>
                <td>
		
		<? $split_netmask = explode(".",$subnet->netmask->ip_addr); ?>
		<? $conf['ui']->show_netmask_select($split_netmask[0]); ?>.
		<? $conf['ui']->show_netmask_select($split_netmask[1]); ?>.
		<? $conf['ui']->show_netmask_select($split_netmask[2]); ?>.
		<? $conf['ui']->show_netmask_select($split_netmask[3]); ?>
		<? 
			if ( $conf['error']->get_status('subnet_netmask') ) {
				$conf['error']->show_message('subnet_netmask');
			}
		?>
                </td>
        </tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->display_plain_txt("subnet_router"); ?>"><? $conf['help']->show_help_link('subnet_router'); ?> Router: </td>
                <td>
			<input name="router" value="<?=  $subnet->router->ip_addr ?>" size="18" maxlength="15" />
		<? 
			if ( $conf['error']->get_status('subnet_router') ) {
				$conf['error']->show_message('subnet_router');
			}
		?>
                </td>
        </tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->display_plain_txt("subnet_status"); ?>"><? $conf['help']->show_help_link('subnet_status'); ?> Status: </td>
                <td>
			<select name="status">
				<option value="visible" <? if ( $subnet->status == 'visible' ) { echo 'SELECTED'; } ?>>Visible</option>
				<option value="hidden" <? if ( $subnet->status == 'hidden' ) { echo 'SELECTED'; } ?>>Hidden</option>
			</select>
                </td>
        </tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->display_plain_txt('generic_comment'); ?>" valign="top"><? $conf['help']->show_help_link('generic_comment'); ?> 
			Comment: 
			<a href="<?= $conf['web_path']; ?>/help.php?action=show_comments&amp;object_id=<?= $subnet->id; ?>&amp;object_name=<?= $subnet->name; ?>&amp;object_type=subnet">
			[View All Comments]
			</a>
		</td>
		<td>	
	        <textarea name="comment" cols="45" rows="5"><?= $history->comment; ?></textarea>
		</td>
	</tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->display_plain_txt("who_update"); ?>"><? $conf['help']->show_help_link("who_update"); ?> Last Updated By: </td>
                <td>
                <? if ($history->username) { ?>
                        <? $conf['ui']->display_field($history->username); ?><?= " on " . date("F j, Y",$history->date) . " at " . date("g:i a",$history->date); ?>
                <? } else { ?>
                        N/A
                <? } ?>
                </td>
        </tr>
	<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td >&nbsp;</td>
		<td>
		<? if ( $action == 'show_create' ) { ?>
			<input type="submit" name="action" value="Create" />
		<? } else { ?>
			<input type="submit" name="action" value="Update" />
			<input type="submit" name="action" value="Delete" />
			<input type="hidden" name="subnet_id" value="<?=  $subnet->id ?>" />
			<!-- If we are using the new_network wizard -->
			<input type="hidden" name="wizard" value="<?= $wizard; ?>" />
		<? } ?>
		</td>
	</tr>
</table>
</form>
<? show_template('bborder'); ?>


<? 
if ($action != 'show_create') { 
	$options = $subnet->get_options();
	$conf['ui']->show_options(0,"subnet",$subnet->id,$options);
} 
?>
